rizq_sanjaya_app/urls.py
from django.urls import path, include
from .views import *
from django.contrib.auth import views as auth_views


app_name = 'profile'
urlpatterns = [
    path('', dashboard.index, name='home'),
    path('calculate_loan', dashboard.calculate_loan, name='calculate_loan'),

    #INI ADALAH YOGYAEXPLORE
    path('profile/', dashboard.profil, name='profil'),
    path('paket/', dashboard.paket, name='paket'),
    path('detail_paket/<int:id>', dashboard.detail_paket, name='detail_paket'),
    path('cara_bayar/', dashboard.cara_bayar, name='cara_bayar'),
    path('gallery/', dashboard.galeri, name='galeri'),
    path('berita/', dashboard.beritaMobil, name='berita'),
    path('detail_info/<str:slug>', dashboard.detail_info, name='detail_info'),
    path('detail_mobil/<str:id>', dashboard.detail_mobil, name='detail_mobil'),
    path('promo/', dashboard.promo, name='promo'),
    path('pricelist/', dashboard.pricelist, name='pricelist'),
    path('category/<int:id>', dashboard.kategori, name='kategori'),
    path('detail_berita/<str:slug>', dashboard.detail_berita, name='detail_berita'),
    path('contact/', dashboard.kontak, name='kontak'),

    # path('gallery/', dashboard.gallery, name='gallerry'),
    path('prev/<int:id>/', dashboard.prev, name='prev'),
    path('next/<int:id>/', dashboard.next, name='next'),
    path('Category/', dashboard.ajax, name='ajax'),
    path('Produk/<int:id>', dashboard.produk, name='produk'),
    path('contact_us/', dashboard.contact, name='contact'),
    path('supplier/', dashboard.supplier, name='supplier'),
    path('render_laporan/', dashboard.render_laporan, name='render_laporan'),
    # url(r'refresh/$', views.captcha_refresh, name='captcha-refresh')
    # path('captcha/refresh/', guestbook.captcha_refresh, name='captcha_refresh'),

    # ABOUT ==================
    path('about/', halaman.index_about, name='idx_about'),
    
    # Mobil ==================
    path('kategori_mobil/<int:id_kat>', mobil_front.index, name='kategori_mobil'),

    # KONTAK PAJERO SPORT ==================
    path('contact/', halaman.index_contact, name='idx_contact'),

    # === Layanan ========================
    path('layanan/', layanan.index, name='layanan'),
    path('layanan/<str:jenis>', layanan.detail, name='layanan'),
    path('layanan/komoditas/<str:jenis>', layanan.detail_komoditas, name='detail_komoditas'),

    # DOKUMEN PUBLIKASI
    # path('dokumen/', documents.index, name='document'),
    # path('dokumen/<str:slug>', documents.detail, name='document_detail'),
    
    # NEWS ========================================
    path('berita/', news.index, name='news'),
    path('berita/<str:slug>', news.detail, name='news_detail'),
    path('berita/category/<str:jenis>/<str:slug>', news.category, name='news_by_category'),

    # DOKUMEN PUBLIKASI
    path('galeri/', gallery.index, name='gallery'),
    path('galeri/<str:slug>', gallery.detail, name='gallery_detail'),
    # path('galeri/category/<str:slug>', gallery.category, name='gallery_by_category'),

    # PAGES
    # path('profil/<str:slug>', pages.index, name='pages'),

    # AGENDA
    # path('agenda/', agenda.index, name='agenda'),
    # path('api/agenda/get', agenda.get_agenda, name='agenda_get'),
    # path('agenda/<str:slug>', agenda.get_agenda_detail, name='agenda_detail'),

    # BUKU TAMU
    # path('buku_tamu/', guestbook.index, name='guestbook'),

    # PENGADUAN
    # path('complaint/', complaint.index, name='complaint'),

    # PENGUMUMAN
    # path('pengumuman/', announcement.index, name='announcement'),
    # path('pengumuman/<str:slug>', announcement.detail_front, name='announcement_detail'),

    # TAGS
    path('tags/<str:jenis>/<str:slug>', tags.index, name='tags'),

    # PASSWORD
    # path("password_reset", user.password_reset_request, name="password_reset"),
    # path('password_reset/done/', auth_views.PasswordResetDoneView.as_view(template_name='profile/admin/user/password/password_reset_done.html'), name='password_reset_done'),
    # path('password/reset/<uidb64>/<token>/', auth_views.PasswordResetConfirmView.as_view(template_name="profile/admin/user/password/password_reset_confirm.html"), name='password_reset_confirm_custom'),

    # PATH URL UNTUK ADMIN 
    path('manage_panel/', include(
        [
            path('', admin.index, name='admin_home'),
            path('verification/', user.verification, name='admin_verification'),
            path('send_verification/', user.send_verification, name='admin_send_verification'),
            path('email/verify/<uidb64>/<token>/',user.email_verify, name='admin_email_verify'),

            # PRODUK =====================================
            path('product/', include(
                [
                    path('', product.admin_index, name='admin_product'),
                    path('add/', product.create, name='admin_product_create'),
                    path('edit/<str:slug>', product.edit, name='admin_product_edit'),
                    path('detail/<str:slug>', product.admin_detail, name='admin_product_detail'),
                    path('soft_delete/<str:slug>', product.softDelete, name='admin_product_soft_delete'),
                    path('permanent_delete/<str:slug>', product.permanentDelete, name='admin_product_permanent_delete'),
                    path('restore/<str:slug>', product.restore, name='admin_product_restore'),
                ]
            )),
            
            # NEWS BERITA
            path('news/', include(
                [
                    path('', news.admin_index, name='admin_news'),
                    path('create/', news.create, name='admin_news_create'),
                    path('edit/<str:slug>', news.edit, name='admin_news_edit'),
                    path('detail/<str:slug>', news.admin_detail, name='admin_news_detail'),
                    path('soft_delete/<str:slug>', news.softDelete, name='admin_news_soft_delete'),
                    path('permanent_delete/<str:slug>', news.permanentDelete, name='admin_news_permanent_delete'),
                    path('restore/<str:slug>', news.restore, name='admin_news_restore'),
                ]
            )),

            path('kata_mereka/', include(
                [
                    path('', kata.admin_index, name='admin_KM'),
                    path('create/', kata.create, name='admin_KM_create'),
                    path('edit/<int:id>', kata.edit, name='admin_KM_edit'),
                    path('detail/<int:id>', kata.admin_detail, name='admin_KM_detail'),
                    path('soft_delete/<int:id>', kata.softDelete, name='admin_KM_soft_delete'),
                    path('permanent_delete/<int:id>', kata.permanentDelete, name='admin_KM_permanent_delete'),
                    path('restore/<int:id>', kata.restore, name='admin_KM_restore'),
                ]
            )),
            path('Keunggulan/', include(
                [
                    path('', keunggulan.admin_index, name='admin_keunggulan'),
                    path('', keunggulan.admin_index, name='admin_keunggulan'),
                    path('create/', keunggulan.create, name='admin_keunggulan_create'),
                    path('edit/<int:id>', keunggulan.edit, name='admin_keunggulan_edit'),
                    path('detail/<int:id>', keunggulan.admin_detail, name='admin_keunggulan_detail'),
                    path('soft_delete/<int:id>', keunggulan.softDelete, name='admin_keunggulan_soft_delete'),
                    path('permanent_delete/<int:id>', keunggulan.permanentDelete, name='admin_keunggulan_permanent_delete'),
                    path('restore/<int:id>', keunggulan.restore, name='admin_keunggulan_restore'),
                ]
            )),
            path('kategori_mobil/', include(
                [
                    
                    path('', kategorimobil.admin_index, name='admin_kateogri_mobil'),
                    path('create/', kategorimobil.create, name='admin_kategorimobil_create'),
                    path('edit/<int:id>', kategorimobil.edit, name='admin_kategorimobil_edit'),
                    path('detail/<int:id>', kategorimobil.admin_detail, name='admin_kategorimobil_detail'),
                    path('soft_delete/<int:id>', kategorimobil.softDelete, name='admin_kategorimobil_soft_delete'),
                    path('permanent_delete/<int:id>', kategorimobil.permanentDelete, name='admin_kategorimobil_permanent_delete'),
                    path('restore/<int:id>', kategorimobil.restore, name='admin_kategorimobil_restore'),
                ]
            )),

            path('pricelist/', include(
                [
                    path('', pricelists.admin_index, name='admin_pricelist_mobil'),
                    path('create/', pricelists.create, name='admin_pricelist_create'),
                    path('edit/<int:id>/', pricelists.edit, name='admin_pricelist_edit'),
                    path('soft_delete/<int:id>', pricelists.softDelete, name='admin_pricelist_soft_delete'),
                    path('permanent_delete/<int:id>', pricelists.permanentDelete, name='admin_pricelist_permanent_delete'),
                    path('restore/<int:id>', pricelists.restore, name='admin_pricelist_restore'),
                ]
            )),

            path('mobil/', include(
                [
                    path('', mobil.admin_index, name='admin_mobil'),
                    path('create/', mobil.create, name='admin_mobil_create'),
                    path('edit/<int:id>', mobil.edit, name='admin_mobil_edit'),
                    path('detail/<int:id>', mobil.admin_detail, name='admin_mobil_detail'),
                    path('soft_delete/<int:id>', mobil.softDelete, name='admin_mobil_soft_delete'),
                    path('restore/<int:id>', mobil.restore, name='admin_mobil_restore'),
                    path('permanent_delete/<int:id>', mobil.permanentDelete, name='admin_mobil_delete'),
                    
                    path('child/', include(

toyotajogja/urls.py
from django.contrib import admin
from django.urls import path,include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('rizq_sanjaya_app.urls')),
    path('accounts/', include("django.contrib.auth.urls")),
]
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

rizq_sanjaya_app/views/_complaint.py
from django.shortcuts import render, HttpResponse, HttpResponseRedirect, redirect
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from ..models import Complaint
import os
from django.conf import settings
from django.core.mail import EmailMessage, get_connection
from django.template.loader import get_template
from django.utils import timezone
from ..decorators import *

@require_http_methods(["GET", "POST"])
def index(request):
    if request.method == 'GET':
        favorits = News.objects.filter(deleted_at=None).order_by('-seen')[:5]
        form = ComplaintForm()
        context = {
            'title' : 'Pengaduan',
            'form' : form,
            'favs' : favorits,
            'captcha' : MyCaptcha(),
        }

        return render(request, 'profile/complaint/index.html', context)
    
    if request.method == 'POST':
        form = ComplaintForm(data=request.POST)
        captcha = MyCaptcha(request.POST)

        if captcha.is_valid():
            if form.is_valid():
                try:
                    message = get_template("profile/email/complaint.html").render({
                        'name': request.POST.get('name'),
                        'email': request.POST.get('email'),
                        'phone': request.POST.get('phone'),
                        'subject': request.POST.get('subject'),
                        'message': request.POST.get('message'),
                    })
                    connection = get_connection(host=settings.EMAIL_HOST, 
                                                port=settings.EMAIL_PORT, 
                                                username=settings.EMAIL_HOST_USER_PENGADUAN, 
                                                password=settings.EMAIL_HOST_PASSWORD_PENGADUAN, 
                                                use_tls=settings.EMAIL_USE_TLS)
                    mail = EmailMessage(
                        subject=request.POST.get('subject'),
                        body=message,
                        to=[
                            # masih perlu diupdate
                            'yoelaris@gmail.com',
                        ],
                        connection=connection,
                    )
                    form.save()
                    
                    mail.content_subtype = "html"
                    mail.send()

                    messages.success(request, 'Pengaduan anda berhasil dikirim.')
                    
                except:
                    messages.success(request, 'Pengaduan anda gagal dikirim.')
                
                return redirect('profile:complaint')
        else:
            messages.error(request, 'Pengaduan anda gagal dikirim. Captcha tidak sama.')
            return redirect('profile:complaint')

        return render(request, 'profile/complaint/index.html', {'form': form})

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_index(request):
    complaint = Complaint.objects.filter(deleted_at = None).order_by('-created_at')
    archives = Complaint.objects.filter(deleted_at__isnull=False).order_by('-created_at')
    context = {
        'title' : 'Pengaduan - Admin',
        'complaints' : complaint,
        'archives' : archives,
    }
    
    return render(request, 'profile/admin/complaint/index.html', context)

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_detail(request, slug):
    template = 'profile/admin/complaint/detail.html'
    try:
        complaint = Complaint.objects.get(slug=slug)
        complaint.read_status=True
        complaint.save()
    except Complaint.DoesNotExist:
        complaint = None
    context = {
        'title' : 'Pengaduan' if complaint != None else 'TIDAK DITEMUKAN',
        'complaint' : complaint,
    }
    return render(request, template, context)

@login_required
@is_verified()
@require_http_methods(["POST"])
def reply(request):
    if request.method == 'POST':
        try:
            complaint = Complaint.objects.get(slug=request.POST.get('slug'))
            message = get_template("profile/email/complaint_reply.html").render({
                'name': complaint.name,
                'subject': complaint.subject,
                'message': complaint.message,
                'reply' : request.POST.get('balasan'),
            })
            connection = get_connection(host=settings.EMAIL_HOST, 
                                        port=settings.EMAIL_PORT, 
                                        username=settings.EMAIL_HOST_USER_PENGADUAN, 
                                        password=settings.EMAIL_HOST_PASSWORD_PENGADUAN, 
                                        use_tls=settings.EMAIL_USE_TLS)
            mail = EmailMessage(
                subject=f"Balasan terhadap pengaduan: {complaint.subject}",
                body=message,
                to=[
                    complaint.email,
                ],
                connection=connection,
            )
            mail.content_subtype = "html"
            mail.send()

            complaint.reply_status = True
            complaint.save()

            messages.success(request, 'Balasan anda berhasil dikirim.')
            return redirect('profile:admin_complaint_detail', slug=complaint.slug)
            
        except:
            messages.success(request, 'Balasan anda gagal dikirim.')
            return redirect('profile:complaint')

@login_required
@is_verified()
def softDelete(request, slug):
    message = ''
    try:
        sekarang = timezone.now()
        complaint = Complaint.objects.get(slug=slug)
        complaint.deleted_at = sekarang
        complaint.save()
        message = 'success'
    except Complaint.DoesNotExist:
        message = 'error'

    context = {
            'message' : message,
        }

    return HttpResponse(context)

@login_required
@is_verified()
def permanentDelete(request, slug):
    message = ''
    try:
        complaint = Complaint.objects.get(slug=slug)
        complaint.delete()
        message = 'success'
    except Complaint.DoesNotExist:
        message = 'error'

    context = {
            'message' : message,
        }

    return HttpResponse(context)
    
@login_required
@is_verified()
def restore(request, slug):
    message = ''
    try:
        complaint = Complaint.objects.get(slug=slug)
        complaint.deleted_at = None
        complaint.save()
        message = 'success'
    except Complaint.DoesNotExist:
        message = 'error'

    context = {
            'message' : message,
        }

    return HttpResponse(context)

rizq_sanjaya_app/templates/profile/_complaint/form.html
<form method ='post' action="{% url 'profile:complaint' %}" >

    {% csrf_token %}
    <div class="form-row">
        <div class="form-group col-md-6">
            <label for="{{ form.name.id_for_label }}">Nama</label>
            <input type="text" placeholder="Masukkan nama anda..."
                class="form-control {% if form.name.errors %}is-invalid{% endif %}"
                name="{{ form.name.name }}"
                id="{{ form.name.id_for_label }}" 
                maxlength="{{ form.name.field.max_length }}"
                {% if form.name.value != None %}value="{{ form.name.value|stringformat:'s' }}"{% endif %}
                {% if form.name.field.required %}required{% endif %} >
            {% if form.name.errors %}
                <div class="invalid-feedback">
                    {{ form.name.errors }}
                </div>
            {% endif %}
        </div>

        <div class="form-group col-md-6">
            <label for="{{ form.email.id_for_label }}">Email</label>
            <input type="email" placeholder="name@example.com"
                class="form-control {% if form.email.errors %}is-invalid{% endif %}"
                name="{{ form.email.name }}"
                id="{{ form.email.id_for_label }}" 
                maxlength="{{ form.email.field.max_length }}"
                {% if form.email.value != None %}value="{{ form.email.value|stringformat:'s' }}"{% endif %}
                {% if form.email.field.required %}required{% endif %} >
            {% if form.email.errors %}
                <div class="invalid-feedback">
                    {{ form.email.errors }}
                </div>
            {% endif %}
        </div>
    </div>

    <div class="form-row">
        <div class="form-group col-md-6">
            <label for="{{ form.phone.id_for_label }}">Nomor Telepon</label>
            <input type="number" placeholder="Masukkan nomor telepon anda (opsional)..."
                class="form-control {% if form.phone.errors %}is-invalid{% endif %}"
                name="{{ form.phone.name }}"
                id="{{ form.phone.id_for_label }}" 
                maxlength="{{ form.phone.field.max_length }}"
                {% if form.phone.value != None %}value="{{ form.phone.value|stringformat:'s' }}"{% endif %}
                {% if form.phone.field.required %}required{% endif %} >
            {% if form.phone.errors %}
                <div class="invalid-feedback">
                    {{ form.phone.errors }}
                </div>
            {% endif %}
        </div>

        <div class="form-group col-md-6">
            <label for="{{ form.subject.id_for_label }}">Judul</label>
            <input type="text" placeholder="Masukkan judul pengaduan..."
                class="form-control {% if form.subject.errors %}is-invalid{% endif %}"
                name="{{ form.subject.name }}"
                id="{{ form.subject.id_for_label }}" 
                maxlength="{{ form.subject.field.max_length }}"
                {% if form.subject.value != None %}value="{{ form.subject.value|stringformat:'s' }}"{% endif %}
                {% if form.subject.field.required %}required{% endif %} >
            {% if form.subject.errors %}
                <div class="invalid-feedback">
                    {{ form.subject.errors }}
                </div>
            {% endif %}
        </div>
    </div>
    <div class="form-group">
        <label for="{{ form.message.id_for_label }}">Pesan</label>
        <textarea type="message" placeholder="Masukkan pesan anda..." rows="4"
            class="form-control {% if form.message.errors %}is-invalid{% endif %}"
            name="{{ form.message.name }}"
            id="{{ form.message.id_for_label }}" 
            maxlength="{{ form.message.field.max_length }}"
            {% if form.message.value != None %}value="{{ form.message.value|stringformat:'s' }}"{% endif %}
            {% if form.message.field.required %}required{% endif %} ></textarea>
        {% if form.message.errors %}
            <div class="invalid-feedback">
                {{ form.message.errors }}
            </div>
        {% endif %}
    </div>

    <div class="form-group">
        <label>Masukan Captcha</label>
        <div id="captcha_purel" alt="{% url 'profile:captcha_refresh' %}">{{captcha.captcha}}
            <a href="#void" class="btn btn-info btn-sm ml-1 my-auto refresh-captcha captcha-refresh" title="Refresh Captcha"><i class="bi bi-bootstrap-reboot"></i></a>
        </div>
    </div>
    <button type="submit" class="btn btn-success"><i class="bi bi-send"></i> Kirim Pengaduan</button>
</form>

rizq_sanjaya_app/templates/profile/_complaint/index.html
{% extends 'profile/layouts/base_layout.html' %}

{% block navbar %}
    {% include 'profile/layouts/navbar.html' %}
{% endblock navbar %}

{% block main %}
<main role="main">
    <div class="jumbotron bg-galeri-head text-putih text-center">
        <div class="container">
            <div class="row">
                <div class="col-md-12 mt-5 mb-auto">
                    <h2 class="mt-3">{{title}} Merapi Trip</h2>
                    <nav aria-label="breadcrumb">
                        <ol class="breadcrumb justify-content-center">
                            <li class="breadcrumb-item"><a href="{% url 'profile:home' %}">Beranda</a></li>
                            <li class="breadcrumb-item active" aria-curent="page">{{title}}</li>
                        </ol>
                    </nav>
                </div>
            </div>
        </div>
    </div>
    <div class="bg-white">
        <div class="container my-5">
            <div class="row bg-white">
                <div class="col-md-8">
                    <h5 id="kategori_berita">Form {{title}}</h5>
                    <hr class="hr-sm mt-0 mb-5" align="left">
                    {% if messages %}
                        {% for message in messages %}
                            <div class="alert {{ message.tags }} my-2" role="alert">
                                {{message}}
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>  
                        {% endfor %}
                    {% endif %}
                    
                    {% include 'profile/complaint/form.html' %}
                </div>

                <div class="col-md-4">
                    <div class="news-sidebar mt-0 mb-3">
                        <h5>Menu Lain</h5>
                        <hr class="hr-sm mt-0" align="left">
                        <div class="news-submenu">
                            <ul>
                                <li><a href="{% url 'profile:announcement' %}" alt="Pengumuman">Pengumuman</a></li>
                                <li><a href="{% url 'profile:agenda' %}" alt="Agenda">Agenda</a></li>
                                <li><a href="{% url 'profile:news' %}" alt="Berita">Berita</a></li>
                                <li><a href="{% url 'profile:gallery' %}" alt="Galeri">Galeri</a></li>
                                <li><a href="{% url 'profile:document' %}" alt="Dokumen Publikasi">Dokumen Publikasi</a></li>
                            </ul>
                        </div>
                    </div>
                    <div class="news-sidebar mt-5 mb-3">
                        <h5>Berita Terfavorit</h5>
                        <hr class="hr-sm mt-0" align="left">
                        {% if favs %}
                        {% for dt in favs %}
                        <div class="berita-kanan">
                            <h4 class="berita-judul-kanan">
                                <a href="{% url 'profile:news_detail' slug=dt.slug %}">{{ dt.title }}</a>
                            </h4>
                            <div class="berita-text-cilik-kanan"><span>{{ dt.created_by.first_name }} {{ dt.created_by.last_name }} | {{ dt.created_at|date:"d M Y" }} | Dilihat : {{ dt.seen }} kali</span></div>
                        </div>
                        {% endfor %}
                        {% else %}
                        <span>Belum Ada Berita Favorit</span>
                        {% endif %}
                    </div>
                </div>

            </div>
        </div>
    </div>

</main>
{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/footer.html' %}
{% endblock footer %}